
%define tbname	NVIDIA_GLX
%define binPkgName nvidia_glx

%define rel alt0.M24.1
%ifndef verrel
%define verrel 1.0-6629
%endif
%ifndef tbsuffix
%define tbsuffix pkg0
%endif
%{expand:%%define VERSION %(echo "%verrel"|cut -d- -f1)}
%{expand:%%define RELEASE %(echo "%verrel"|cut -d- -f2)}

%define myGroup System/Kernel and hardware
%define mySummary NVIDIA drivers and OpenGL libraries for XFree86 4.x X-server
%define mySummaryRu Драйверы NVIDIA и библиотеки OpenGL для Х-сервера XFree86 4.x
%define myUrl http://www.nvidia.com
%define myVendor NVIDIA Corp.
%define myLicense NVIDIA

Source: ftp://download.nvidia.com/XFree86/Linux-x86/%verrel/NVIDIA-Linux-x86-%verrel-%tbsuffix.run
Source1: nvidia_set_glx
Source2: nvidia_glx.rc
Source3: nvidia_glx.firsttime
Source4: nvidia_glx.sysconfig


Name: %{binPkgName}_src_%{VERSION}.%{RELEASE}
Version: %VERSION.%RELEASE
Release: %rel

Packager: Andrei Bulava <abulava@altlinux.ru>

%define exts /modules/extensions
%define drvs /modules/drivers
%define nvlibdir %_x11libdir/nvidia_%version

Group: %myGroup
Summary: %mySummary
Summary(ru_RU.UTF-8): %mySummaryRu
Url: %myUrl
Vendor: %myVendor
License: %myLicense
%description
Sources for %{binPkgName}_%{version} package



%package -n %{binPkgName}_common
Requires(post): %post_service chkconfig
Requires(preun): %preun_service
Conflicts: fglrx_glx <= 3.11.1-alt1
#Obsoletes: %tbname
#
Group: %myGroup
Summary: This is common package for usability NVIDIA drivers.
Summary(ru_RU.UTF-8): Пакет для совместимости драйверов NVIDIA.
Url: %myUrl
Vendor: %myVendor
License: %myLicense
#
%description -n %{binPkgName}_common
This is common package for NVIDIA drivers.
#
%description -n %{binPkgName}_common -l ru_RU.UTF-8
Этот пакет нужен для совместимости при отсутствии
одной из компонент драйверов для NVIDIA.



%package -n %{binPkgName}_%{version}
Requires(post): service chkconfig
PreReq: %{binPkgName}_common >= %version
#Requires: XFree86-server >= 4.0.3
#Requires: libGLwrapper
Requires: NVIDIA_kernel = %version
Provides: libGL
Provides: %tbname = %version-%release
Obsoletes: %tbname
#
Group: %myGroup
Summary: %mySummary
Summary(ru_RU.UTF-8): %mySummaryRu
Url: %myUrl
Vendor: %myVendor
License: %myLicense
#
%description -n %{binPkgName}_%{version}
NVIDIA XFree86 4.x server drivers and OpenGL libraries for RIVA TNT/TNT2
and GeForce/Quadro based video cards.  Older RIVA 128 based video cards are
supported by the server module shipping with XFree86 4.x, nv_drv.o. You
should install this package if you have one of the newer cards.

You must also install the NVIDIA_kernel package if you want
NVIDIA module and OpenGL libraries for XFree86 4.x X server.
#
%description -n %{binPkgName}_%{version} -l ru_RU.UTF-8
Драйверы и OpenGL-библиотеки для Х-сервера XFree86 4.x и видеокарт NVIDIA
на базе RIVA TNT/TNT2 и GeForce/Quadro. Более ранние версии видеокарт на базе
RIVA 128 поддерживаются модулем nv_drv.o, входящим в состав сервера XFree86 4.x.
Если вы имеете одну из этих новых видеокарт, то вам желательно установить данный
пакет.

Если вы желаете использовать модули NVIDIA и библиотеки OpenGL для Х-сервера XFree86 4.0,
то вы должны также установить пакет NVIDIA_kernel.



%prep
%setup -T -c -n NVIDIA-Linux-x86-%verrel-%tbsuffix
rm -rf %_builddir/NVIDIA-Linux-x86-%verrel-%tbsuffix
cd %_builddir
sh %SOURCE0 -x

%build
%install
%set_verify_elf_method textrel=relaxed
%set_strip_method none
%add_findprov_lib_path %nvlibdir

soname()
{
    readelf -a $1| grep SONAME| sed 's/.*\[//'| sed 's/\].*//'
}

%__mkdir_p %buildroot/%_sbindir
%__mkdir_p %buildroot/%_sysconfdir/rc.d/init.d
%__mkdir_p %buildroot/%_sysconfdir/firsttime.d
%__mkdir_p %buildroot/%_sysconfdir/sysconfig
%__mkdir_p %buildroot/%_x11libdir/nvidia_common
%__mkdir_p %buildroot/%nvlibdir/%drvs
%__mkdir_p %buildroot/%nvlibdir/%exts

%__install -m 755 %SOURCE1 %buildroot/%_sbindir/nvidia_set_glx
%__install -m 755 %SOURCE2 %buildroot/%_sysconfdir/rc.d/init.d/nvidia_glx
%__install -m 755 %SOURCE3 %buildroot/%_sysconfdir/firsttime.d/nvidia_glx
%__install -m 644 %SOURCE4 %buildroot/%_sysconfdir/sysconfig/nvidia_glx

%__install usr/X11R6/lib/%drvs/nvidia_drv.o      %buildroot/%nvlibdir/%drvs/

%__install usr/X11R6/lib/%exts/libglx.so.%version %buildroot/%nvlibdir/%exts/libglx.so.nvidia
%__ln_s libglx.so.nvidia %buildroot/%nvlibdir/%exts/libglx.so

%__install usr/lib/libGL.so.%version  %buildroot/%nvlibdir/libGL.so.nvidia

%__install usr/lib/libGLcore.so.%version %buildroot/%nvlibdir/libGLcore.so.nvidia
%__ln_s libGLcore.so.nvidia %buildroot/%nvlibdir/`soname %buildroot/%nvlibdir/libGLcore.so.nvidia`

%__install usr/X11R6/lib/libXvMCNVIDIA.so.%version %buildroot/%nvlibdir/libXvMCNVIDIA.so.%version
%__ln_s libXvMCNVIDIA.so.%version %buildroot/%nvlibdir/libXvMC.so.nvidia
%__ln_s libXvMCNVIDIA.so.%version %buildroot/%nvlibdir/`soname usr/X11R6/lib/libXvMCNVIDIA.so.%version` 

%__install usr/lib/libnvidia-tls.so.%version %buildroot/%nvlibdir/libnvidia-tls.so.%version
%__ln_s libnvidia-tls.so.%version %buildroot/%nvlibdir/libnvidia-tls.so.nvidia
%__ln_s libnvidia-tls.so.%version %buildroot/%nvlibdir/`soname usr/lib/libnvidia-tls.so.%version` 

# greate ghost files
%__mkdir_p %buildroot/%_libdir/
%__mkdir_p %buildroot/%_x11libdir/modules/{drivers,extensions}/
%__ln_s /dev/null %buildroot/%_x11libdir/modules/drivers/nvidia_drv.o
%__ln_s /dev/null %buildroot/%_x11libdir/modules/extensions/libglx.so
%__ln_s /dev/null %buildroot/%_x11libdir/libGL.so.nvidia
%__ln_s /dev/null %buildroot/%_libdir/libGLcore.so.1
%__ln_s /dev/null %buildroot/%_x11libdir/libGLcore.so.1
%__ln_s /dev/null %buildroot/%_x11libdir/libXvMCNVIDIA_dynamic.so.1
%__ln_s /dev/null %buildroot/%_x11libdir/libnvidia-tls.so.1


%post -n %{binPkgName}_%{version}
%post_ldconfig
echo "You must execute \"service nvidia_glx start\""
echo "to switch NVIDIA drivers for current kernel."

%postun -n %{binPkgName}_%{version}
%postun_ldconfig



%post -n %{binPkgName}_common
%post_ldconfig
%post_service nvidia_glx

%preun -n %{binPkgName}_common
%preun_service nvidia_glx

%postun -n %{binPkgName}_common
%postun_ldconfig



%files -n %{binPkgName}_%{version}
%doc LICENSE
%doc usr/share/doc/*
%doc usr/include
#
%defattr (0555, root, root)
#
%dir %nvlibdir
%dir %nvlibdir/%drvs
%dir %nvlibdir/%exts
%nvlibdir/%drvs/nvidia_drv.o
%nvlibdir/%exts/libglx.so
%nvlibdir/%exts/libglx.so.nvidia
%nvlibdir/libGL.so.nvidia
%nvlibdir/libGLcore.so.?
%nvlibdir/libGLcore.so.nvidia
%nvlibdir/libXvMC*.so.*
%nvlibdir/libnvidia-tls.so.*

%files -n %{binPkgName}_common
%_sbindir/nvidia_set_glx
%_sysconfdir/firsttime.d/nvidia_glx
%config %_sysconfdir/rc.d/init.d/nvidia_glx
%config(noreplace) %_sysconfdir/sysconfig/nvidia_glx
%ghost %_x11libdir/modules/drivers/nvidia_drv.o
%ghost %_x11libdir/modules/extensions/libglx.so
%ghost %_x11libdir/libGL.so.nvidia
%ghost %_libdir/libGLcore.so.?
%ghost %_x11libdir/libGLcore.so.?
%ghost %_x11libdir/libXvMCNVIDIA_dynamic.so.?
%ghost %_x11libdir/libnvidia-tls.so.?

%changelog
* Thu Mar 10 2005 Andrei Bulava <abulava@altlinux.ru> 1.0.6629-alt0.M24.1
- backported to Master 2.4
- added /etc/sysconfig/nvidia_glx in order to provide a possibility to force
  nvidia_glx service running regardless of hwdatabase doesn't include modern
  nVidia videocards

* Mon Nov 22 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6629-alt1
- new version

* Fri Oct 08 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6111-alt2
- try to fix link to libGL.so.1 when service nvidia_glx starts

* Fri Aug 06 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6111-alt1
- new version

* Mon Jul 19 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt4
- ignore non-NVIDIA videocards via pciscan in initscript

* Tue Jul 13 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt3
- add %%ghost files to -common package

* Fri Jul 02 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt2
- fix libnvidia-tls.so.1 link placement

* Fri Jul 02 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt1
- new version

* Tue Feb 03 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.5336-alt1
- new version

* Mon Jan 19 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.5328-alt2
- initscript compatible with 2.6.x kernels
- add start on 3,4 runlevels

* Tue Dec 23 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.5328-alt1
- new version

* Tue Dec 23 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt7
- fix initscript status message

* Thu Oct 30 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt6
- fix initscript fail message

* Fri Sep 26 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt5
- fix %%post

* Fri Sep 26 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt4
- force install service nvidia_lgx when variable DURING_INSTALL=1

* Mon Sep 15 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt3
- fix initscript

* Mon Sep 15 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4363-alt2
- make possible to install different versions together

* Wed Jul 30 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt1
- new version

* Tue Jul 01 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4363-alt1
- new version

* Tue May 06 2003 Sergey V Turchin <zerg at altlinux dot ru> 1.0.4349-alt2
- remove requires to XFree86-server libGLwrapper
- remove very old versions from %%versions

* Wed Apr 02 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.4349-alt1
- New upstream version

* Sun Feb 16 2003 Aleksandr Blokhin 'Sass' <sass@altlinux.ru> 1.0.4191-alt3
- Fixed file permissions on %%doc
- Added Summary and %%description in Russian

* Fri Dec 20 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.4191-alt2
- fix link to %xlibdir/%exts/libglx.so

* Thu Dec 19 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.4191-alt1
- new version

* Fri Sep 13 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.0.3123-alt1
- new version

* Thu Jun 06 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.0.2960-alt1
- new version

* Fri Mar 15 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.2802-alt1
- new version

* Fri Feb 22 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.2313-alt1
- prepare for Sisyphus

* Thu Jan 31 2002 Sergey V Turchin <zerg@altlinux.ru> ALL-alt2
- fix requires
- cleanup spec

* Tue Jan 29 2002 Sergey V Turchin <zerg@altlinux.ru> ALL-alt1
- add interactive build

* Sat Dec 29 2001 Ivan Zakharyaschev <imz@altlinux.ru> 1.0.2313-alt3
- fix requires version (add 1.0 prefix)

* Tue Dec 18 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.0.2313-alt2
- Fixed requires as kernel_version of this driver is 2314

* Wed Dec 05 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.2313-alt1
- new version

* Thu Jun 14 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1251-alt5
- changed pakage name to nvidiaGL

* Fri Jun 08 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1251-alt4
- fix requires

* Wed May 23 2001 Sergey V Turchin <zerg@altlinux.ru>
- first build
